<?php
class digits_ADP_SMS_Webservice {
	const WSDL_URL = 'https://ws.adpdigital.com/services/MessagingService?wsdl';

	private $_clinet;

	private $_username;
	private $_password;
	private $_shortNumber;


	public function __construct($username, $password, $short_number) {
		$options = array('encoding' => 'UTF-8', 'connection_timeout' => 15, 'use' => SOAP_LITERAL, 'style'=>SOAP_DOCUMENT);
		$this->_username = $username;
		$this->_password = $password;
		$this->_shortNumber = $short_number;
		$this->_clinet = new SoapClient(self::WSDL_URL, $options);
	}

	public function send($to, $msg) {

		$param = new stdClass();
		$param->userName = $this->_username;
		$param->password = $this->_password;
		$param->sourceNo = $this->_shortNumber;
		$param->destNo = $to;
		$param->sourcePort = null;
		$param->destPort = null;
		$param->clientId = array();
		$param->messageType = 1;
		$param->encoding = 2;
		$param->longSupported = true;
		$param->dueTime = time();
		$param->content = $msg;

		return $this->_clinet->send($param);
	}

	public function balance($facility) {
		$param = new stdClass();
		$param->userName = $this->_username;
		$param->password = $this->_password;
		$param->facilityId = $facility;
		return $this->_clinet->getBalance($param);
	}

	public function debug() {
		echo '<pre>';
		var_dump($this->_clinet->__getTypes());
		var_dump($this->_clinet->__getFunctions());
		echo '</pre>';
	}
}