<?php
/**
* FaraPayamak PHP API
*
* @package     Karin Payamak
* @copyright   PersianScript.ir 2018
* @license     MIT
* @link        http://persianscript.ir
* @version     1.0.0
*/


if ($_GET['page'] ==('digits_settings')){
	wp_enqueue_script('farapayamak-gateway-script', plugins_url('digits/gateways/farapayamak/farapayamak.js'), array(), null, 'all');
	wp_localize_script('farapayamak-gateway-script', 'smsKarindata', array('cssUrl' => plugins_url('digits/gateways/farapayamak/')));
}


class digits_FaraPayamak {

  
  private $Mversion = '1.0.0';

  
  private $username;
  
  
  private $Password;


  
  private $sender;


  
  public $log;

  
  public $invalid_char_action;

  
  public function __construct($arg ,array $options = array()) {
    if (empty($arg)) {
      error_log("Username and Password and Sender can't be blank");
    } else {
      $this->username = $arg['username'];
      $this->password = $arg['password'];
      $this->sender = $arg['sender'];
    }
    $this->invalid_char_action  = (array_key_exists('invalid_char_action', $options)) ? $options['invalid_char_action'] : null;
    $this->log                  = (array_key_exists('log', $options)) ? $options['log'] : false;
  }

  /**
  * Send some text messages
  * @author  Mohammad Majidi
  */
  public function send(array $sms) {
    if (!is_array($sms)) {
      error_log("sms parameter must be an array");
    }

	$encoding = "UTF-8";//CP1256, CP1252
	$textMessage = iconv($encoding, 'UTF-8//TRANSLIT',$sms['message']);
	
	$sendsms_parameters = array(
		'username' => $this->username,
		'password' => $this->password,
		'from' => $this->sender,
		'to' => array($sms['to']),
		'text' => $textMessage,
		'isflash' => false,
		'udh' => "",
		'recId' => array(0),
		'status' => 0
	);
	$client = new SoapClient("http://api.payamak-panel.com/post/send.asmx?wsdl");
	$status = $client->SendSms($sendsms_parameters)->SendSmsResult;
	$statusCodes = array(
		'0' =>    'نام کاربری و رمز اشتباه',
		'1' =>    'ارسال موفق',
		'2' =>    'کمبود اعتبار',
		'3' =>    'محدودیت ارسال روزانه!',
		'4' =>    'محدودیت در ارسال!',
		'5' =>    'شماره مجازی غیر مجاز!',
		'6' =>    'در صف ارسال',
		'7' => 'کلمات فیلتر شده!',
		);
	if ($status == '1') {
		if($this->log) error_log("FaraPayamak : SMS sent json query:".json_encode(array('message'=>$sms['message'],'to'=>$sms['to'],'result'=>$statusCodes[$status])));
		return array('success'=>true);
	} else {
		if($this->log) error_log("FaraPayamak : SMS failed json query:".json_encode(array('message'=>$sms['message'],'to'=>$sms['to'],'error'=>$statusCodes[$status] ? $statusCodes[$status] : 'Unknow Error:'.$status)));
		return array('success'=>false);
	}
  }

}
