<?php
/**
* ippanel PHP API
*
* @package     ippanel SMS
* @copyright   ippanel 2018
* @author      hadi mollaei<mr.hadimollaei@gmail.com>
* @link        http://www.ippanel.com
* @version     1.0.1
*/
$protocol = 'http:';
if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
    $protocol = 'https:';
}
elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && $_SERVER['HTTP_X_FORWARDED_SSL'] == 'on') {
    $protocol = 'https:';
}

/**
* Main Ippanel SMS API Class
* 
* @package     Ippanel
* @since       1.0
*/
class digits_max_sms {

  /*
  * Version of this class
  */
  private $Mversion = '1.0.1';

  /** 
  * Ippanel SMS API Username
  * 
  * @var string
  */
  private $username;
  
  /** 
  * Ippanel SMS API Password
  * 
  * @var string
  */
  private $Password;


  /**
  * From line used on text messages
  *
  * @var string (11 characters or 12 numbers)
  */
  private $sender;

  /**
  * Create a new instance of the Clockwork wrapper
  *
  * @param   string  key         Your Clockwork API Key
  * @param   array   options     Optional parameters for sending SMS
  */
  public function __construct($arg ,array $options = array()) {
    if (empty($arg)) {
      error_log("Username and Password and Sender can't be blank");
    } else {
      $this->username = $arg['username'];
      $this->password = $arg['password'];
      $this->sender = $arg['sender'];
    }
  }

  /**
  * Send some text messages
  * @author  Hadi Mollaei
  */
  public function send(array $sms) {

    if (!is_array($sms)) {
      error_log("sms parameter must be an array");
    }
	$url = '37.130.202.188/services.jspd';
	$rcpt_nm = array($sms['to']);
	$param = array
				(
					'uname'=> $this->username,
					'pass'=>$this->password,
					'from'=>$this->sender,
					'message'=> $sms['message'],
					'to'=>json_encode($rcpt_nm),
					'op'=>'send',
				);
				
	$handler = curl_init($url);             
	curl_setopt($handler, CURLOPT_CUSTOMREQUEST, "POST");
	curl_setopt($handler, CURLOPT_POSTFIELDS, $param);                       
	curl_setopt($handler, CURLOPT_RETURNTRANSFER, true);
	$response = curl_exec($handler);
	$response2 = json_decode($response);
	$res_code = $response2[0];
	$res_data = $response2[1];
	$errorCodes = array(
		'1' =>    'The message is empty!',
		'2' =>    'The user is limited!',
		'3' =>    'The Number is not belong to you!',
		'4' =>    'You have no reciver!',
		'5' =>    'You do not have enough credit!',
		'6' =>    'The message length is not proper!',
		'7' =>    'The line is not for send all',
		'98' => 'The maximum reciver is not alowed!',
		'99' => 'The operator is Off!',
		'962' =>'The username or password is incorrect!',
		'963' =>'The user is limited!',
		);
	if ($res_code == '0') {
		error_log("IppanelSMS : SMS sent json query:".json_encode(array('message'=>$sms['message'],'to'=>$sms['to'],'bulk'=>$res_data)));
		return array('success'=>true);
	} else {
		error_log($errorCodes[$res_code].'-'. $res_code);
		return array('success'=>false);
	}
  }

}
